]> git.ipfire.org Git - thirdparty/systemd.git/blobdiff - mkosi.build
mkosi: remove intltool from deps
[thirdparty/systemd.git] / mkosi.build
index 872841eb63e39e0b2386c46c9c22558646666713..38cfe2502509697e1cf1b78d71ad9f712fcc2d5e 100755 (executable)
@@ -1,4 +1,5 @@
-#!/bin/sh -ex
+#!/bin/sh
+set -ex
 
 # This file is part of systemd.
 #
 # This is a build script for OS image generation using mkosi (https://github.com/systemd/mkosi).
 # Simply invoke "mkosi" in the project directory to build an OS image.
 
-./autogen.sh c
-make -j `nproc`
+# If mkosi.builddir/ exists mkosi will set $BUILDDIR to it, let's then use it
+# as out-of-tree build dir. Otherwise, let's make up our own builddir.
+[ -z "$BUILDDIR" ] && BUILDDIR=build
 
-make check
-make install
+export LC_CTYPE=en_US.UTF-8
 
-mkdir -p $DESTDIR/etc
+sysvinit_path=`realpath /etc/init.d`
 
-cat > $DESTDIR/etc/issue <<EOF
+nobody_user=`id -u -n 65534 2> /dev/null`
+if [ "$nobody_user" != "" ] ; then
+        # Validate that we can translate forth and back
+        if [ "`id -u $nobody_user`" != 65534 ] ; then
+                nobody_user=""
+        fi
+fi
+if [ "$nobody_user" = "" ] ; then
+        if id -u nobody 2> /dev/null ; then
+                # The "nobody" user is defined already for something else, pick the Fedora name
+                nobody_user=nfsnobody
+        else
+                # The "nobody" user name is free, use it
+                nobody_user=nobody
+        fi
+fi
+
+nobody_group=`id -g -n 65534 2> /dev/null`
+if [ "$nobody_group" != "" ] ; then
+        # Validate that we can translate forth and back
+        if [ "`id -g $nobody_group`" != 65534 ] ; then
+                nobody_group=""
+        fi
+fi
+if [ "$nobody_group" = "" ] ; then
+        if id -u nobody 2> /dev/null ; then
+                # The "nobody" group is defined already for something else, pick the Fedora name
+                nobody_group=nfsnobody
+        else
+                # The "nobody" group name is free, use it
+                nobody_group=nobody
+        fi
+fi
+
+[ -f "$BUILDDIR"/build.ninja ] || meson "$BUILDDIR" -D "sysvinit-path=$sysvinit_path" -D default-hierarchy=unified -D man=false -D "nobody-user=$nobody_user" -D "nobody-group=$nobody_group"
+ninja -C "$BUILDDIR" all
+[ "$WITH_TESTS" = 0 ] || ninja -C "$BUILDDIR" test || ( RET="$?" ; cat "$BUILDDIR"/meson-logs/testlog.txt ; exit "$RET" )
+ninja -C "$BUILDDIR" install
+
+mkdir -p "$DESTDIR"/etc
+
+cat > "$DESTDIR"/etc/issue <<EOF
 \S (built from systemd tree)
 Kernel \r on an \m (\l)